// Code generated by mockery v2.33.3. DO NOT EDIT.

package mocks

import (
	context "context"

	common "gitlab.com/cyverse/cacao-common/common"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/cyverse/cacao/workspace-service/types"
)

// PersistentStoragePort is an autogenerated mock type for the PersistentStoragePort type
type PersistentStoragePort struct {
	mock.Mock
}

// Create provides a mock function with given fields: ctx, workspace
func (_m *PersistentStoragePort) Create(ctx context.Context, workspace types.Workspace) error {
	ret := _m.Called(ctx, workspace)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, types.Workspace) error); ok {
		r0 = rf(ctx, workspace)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Delete provides a mock function with given fields: ctx, user, workspaceID
func (_m *PersistentStoragePort) Delete(ctx context.Context, user string, workspaceID common.ID) error {
	ret := _m.Called(ctx, user, workspaceID)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, common.ID) error); ok {
		r0 = rf(ctx, user, workspaceID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Get provides a mock function with given fields: ctx, user, workspaceID
func (_m *PersistentStoragePort) Get(ctx context.Context, user string, workspaceID common.ID) (types.Workspace, error) {
	ret := _m.Called(ctx, user, workspaceID)

	var r0 types.Workspace
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, common.ID) (types.Workspace, error)); ok {
		return rf(ctx, user, workspaceID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, common.ID) types.Workspace); ok {
		r0 = rf(ctx, user, workspaceID)
	} else {
		r0 = ret.Get(0).(types.Workspace)
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, common.ID) error); ok {
		r1 = rf(ctx, user, workspaceID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Init provides a mock function with given fields: config
func (_m *PersistentStoragePort) Init(config *types.Config) error {
	ret := _m.Called(config)

	var r0 error
	if rf, ok := ret.Get(0).(func(*types.Config) error); ok {
		r0 = rf(config)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// List provides a mock function with given fields: ctx, user
func (_m *PersistentStoragePort) List(ctx context.Context, user string) ([]types.Workspace, error) {
	ret := _m.Called(ctx, user)

	var r0 []types.Workspace
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) ([]types.Workspace, error)); ok {
		return rf(ctx, user)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) []types.Workspace); ok {
		r0 = rf(ctx, user)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]types.Workspace)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, user)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Update provides a mock function with given fields: ctx, workspace, updateFieldNames
func (_m *PersistentStoragePort) Update(ctx context.Context, workspace types.Workspace, updateFieldNames []string) error {
	ret := _m.Called(ctx, workspace, updateFieldNames)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, types.Workspace, []string) error); ok {
		r0 = rf(ctx, workspace, updateFieldNames)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// NewPersistentStoragePort creates a new instance of PersistentStoragePort. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewPersistentStoragePort(t interface {
	mock.TestingT
	Cleanup(func())
}) *PersistentStoragePort {
	mock := &PersistentStoragePort{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
